{(*}
(*------------------------------------------------------------------------------
 Delphi Code formatter source code

The Original Code is SetClarify.pas, released April 2000.
The Initial Developer of the Original Code is Anthony Steele.
Portions created by Anthony Steele are Copyright (C) 1999-2000 Anthony Steele.
All Rights Reserved.
Contributor(s): Anthony Steele. 

The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"). you may not use this file except in compliance with the License.
You may obtain a copy of the License at http://www.mozilla.org/NPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied.
See the License for the specific language governing rights and limitations 
under the License.
------------------------------------------------------------------------------*)
{*)}

{ generic clarify options that don't go elsewhere }

unit SetClarify;

interface

uses JCFSetBase, TokenType;

type

  TSetClarify = class(TSetBase)
  private
    fbOnceOffs: boolean;
    fbWarnings: boolean;

  public
    constructor Create;

    procedure Read; override;
    procedure Write; override;


    property OnceOffs: boolean read fbOnceOffs write fbOnceOffs;
    property Warnings: boolean read fbWarnings write fbWarnings;
  end;

implementation

const
  REG_ONCE_OFFS = 'OnceOffs';
  REG_WARNINGS  = 'Warnings';

  { TSetClarify }

constructor TSetClarify.Create;
begin
  inherited;
  SetSection('Clarify');
end;

procedure TSetClarify.Read;
begin
  fbOnceOffs := ReadItem(REG_ONCE_OFFS, False);
  fbWarnings := ReadItem(REG_WARNINGS, True);
end;

procedure TSetClarify.Write;
begin
  WriteItem(REG_ONCE_OFFS, fbOnceOffs);
  WriteItem(REG_WARNINGS, fbWarnings);
end;

end.